#version 430 core

in vec2 textureCoords;

out vec4 out_Colour;

layout(location=0)uniform sampler2D colorTexture;


const float offset = 1.0 / 300.0;  

void main()
{
	vec3 grayscale = texture(colorTexture, textureCoords).rrr;

    vec2 offsets[9] = vec2[](
        vec2(-offset,  offset), // top-left
        vec2( 0.0f,    offset), // top-center
        vec2( offset,  offset), // top-right
        vec2(-offset,  0.0f),   // center-left
        vec2( 0.0f,    0.0f),   // center-center
        vec2( offset,  0.0f),   // center-right
        vec2(-offset, -offset), // bottom-left
        vec2( 0.0f,   -offset), // bottom-center
        vec2( offset, -offset)  // bottom-right    
    );

    float kernel[9] = float[](
        1,  0, -1,
        2,  0, -2,
        1,  0, -1
    );

	float kernel2[9] = float[](
        1,  2,  1,
        0,  0,  0,
       -1, -2, -1
    );
    
    vec3 sampleTex[9];
    for(int i = 0; i < 9; i++)
    {
        sampleTex[i] = vec3(texture(colorTexture, textureCoords.st + offsets[i]).rrr);
    }
	
    vec3 col = vec3(0.0);
	vec3 col2 = vec3(0.0);
    for(int i = 0; i < 9; i++){
		col += sampleTex[i] * kernel[i];
		col2 += sampleTex[i] * kernel2[i];
	}
    vec3 test = sqrt(pow(col,vec3(2,2,2)) + pow(col2,vec3(2,2,2)));
	test = step(0.01,test);
    out_Colour = vec4(test, 1.0) ;
} 
/*
void main(void)
{
	//should be basic inversion of image
	out_Colour = vec4(vec3(1.0 - texture(colorTexture, textureCoords)), 1.0);
}*/